Bug 816335 - btrfs panic mounting filesystem
btrfs panic mounting filesystem
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
17
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Zach Brown
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-04-25 16:03 EDT by Richard W.M. Jones
Modified: 2015-05-17 21:40 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-06-26 17:03:51 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
possible fix (3.12 KB, patch)
2012-04-26 11:02 EDT, Josef Bacik
no flags Details | Diff

  None (edit)
Description Richard W.M. Jones 2012-04-25 16:03:48 EDT
Description of problem:

This just started happening.  Only change was installing
btrfs-progs-0.19-19.fc18.x86_64 in order to fix
bug 816293, but I don't see how that could possibly
be related.

mount -o  /dev/vda1 /sysroot/
[    4.925436] device fsid 59fa32e2-aefd-45e3-9ed3-ef956e35191b devid 1 transid 4 /dev/vda1
[    4.940185] btrfs: disk space caching is enabled
[    4.945866] parent transid verify failed on 131072 wanted 4 found 2
[    4.946958] unable to find logical 4214784 len 4096
[    4.947702] ------------[ cut here ]------------
[    4.948481] kernel BUG at fs/btrfs/volumes.c:3653!
[    4.948971] invalid opcode: 0000 [#1] SMP 
[    4.949415] CPU 0 
[    4.949600] Modules linked in: btrfs zlib_deflate i2c_piix4 i2c_core virtio_net virtio_scsi virtio_blk virtio_rng virtio_balloon virtio_mmio sparse_keymap rfkill sym53c8xx scsi_transport_spi crc7 crc8 crc_ccitt crc_itu_t libcrc32c
[    4.951870] 
[    4.952034] Pid: 125, comm: mount Not tainted 3.3.2-1.fc17.x86_64.debug #1 Bochs Bochs
[    4.952820] RIP: 0010:[<ffffffffa00e6ecf>]  [<ffffffffa00e6ecf>] __btrfs_map_block+0x62f/0x640 [btrfs]
[    4.953764] RSP: 0018:ffff88001ae1d898  EFLAGS: 00010296
[    4.954275] RAX: 000000000000003d RBX: 0000000000405000 RCX: 0000000000000006
[    4.954973] RDX: 0000000000000000 RSI: ffff88001ade2b28 RDI: 0000000000000246
[    4.955641] RBP: ffff88001ae1d918 R08: 0000000000000000 R09: 0000000000000000
[    4.956366] R10: 0000000000000001 R11: 0000000000000000 R12: ffff88001ae802d8
[    4.957085] R13: ffff88001ae802e0 R14: ffff88001ae1d968 R15: 0000000000001000
[    4.957754] FS:  00007f394ada5840(0000) GS:ffff88001f000000(0000) knlGS:0000000000000000
[    4.958564] CS:  0010 DS: 0000 ES: 0000 CR0: 000000008005003b
[    4.959140] CR2: 00007f8b47794000 CR3: 000000001ad28000 CR4: 00000000000006f0
[    4.959840] DR0: 0000000000000000 DR1: 0000000000000000 DR2: 0000000000000000
[    4.960562] DR3: 0000000000000000 DR6: 00000000ffff0ff0 DR7: 0000000000000400
[    4.961258] Process mount (pid: 125, threadinfo ffff88001ae1c000, task ffff88001ade2450)
[    4.962064] Stack:
[    4.962266]  ffffffffa00ba54d 0000005000000002 ffff88001ae1d8b8 ffffffff811f2a4f
[    4.963098]  0000000000000000 ffff88001ae1d970 ffff88001ae1d8f8 0000000000000246
[    4.963883]  0000000000000000 0000000000000000 00000000000003a9 0000000000405000
[    4.964672] Call Trace:
[    4.964935]  [<ffffffffa00ba54d>] ? btrfs_bio_wq_end_io+0x3d/0x90 [btrfs]
[    4.965597]  [<ffffffff811f2a4f>] ? bio_add_page+0x4f/0x60
[    4.966168]  [<ffffffffa00ead1f>] btrfs_map_bio+0x5f/0x250 [btrfs]
[    4.966756]  [<ffffffff811a0029>] ? kmem_cache_alloc_trace+0xd9/0x240
[    4.967410]  [<ffffffffa00de970>] ? repair_io_failure+0x290/0x290 [btrfs]
[    4.968104]  [<ffffffffa00ba840>] btree_submit_bio_hook+0xc0/0xd0 [btrfs]
[    4.968739]  [<ffffffffa00dbc0a>] submit_one_bio+0x6a/0xa0 [btrfs]
[    4.969395]  [<ffffffffa00e288b>] read_extent_buffer_pages+0x38b/0x8a0 [btrfs]
[    4.970128]  [<ffffffffa00b82d0>] ? verify_parent_transid+0x160/0x160 [btrfs]
[    4.970816]  [<ffffffffa00b8a08>] btree_read_extent_buffer_pages.isra.97+0x88/0xc0 [btrfs]
[    4.971645]  [<ffffffffa00baba1>] read_tree_block+0x41/0x60 [btrfs]
[    4.972273]  [<ffffffffa00bea62>] open_ctree+0x1302/0x1a20 [btrfs]
[    4.972916]  [<ffffffff813083e1>] ? disk_name+0x61/0xc0
[    4.973452]  [<ffffffffa009b312>] btrfs_mount+0x592/0x680 [btrfs]
[    4.974056]  [<ffffffff81170de5>] ? pcpu_alloc+0x8e5/0x9e0
[    4.974610]  [<ffffffff811bd453>] mount_fs+0x43/0x1b0
[    4.975111]  [<ffffffff81170ef0>] ? __alloc_percpu+0x10/0x20
[    4.975676]  [<ffffffff811da4ff>] vfs_kern_mount+0x6f/0x100
[    4.976227]  [<ffffffff811db084>] do_kern_mount+0x54/0x110
[    4.976778]  [<ffffffff811dc8ea>] do_mount+0x26a/0x840
[    4.977289]  [<ffffffff8116ae3b>] ? strndup_user+0x5b/0x80
[    4.977817]  [<ffffffff811dcffd>] sys_mount+0x8d/0xe0
[    4.978341]  [<ffffffff816a45e9>] system_call_fastpath+0x16/0x1b
[    4.978921] Code: e3 89 da eb b2 0f 0b 0f 0b c7 45 c4 01 00 00 00 31 db e9 25 fe ff ff 49 8b 16 48 89 de 48 c7 c7 d0 14 12 a0 31 c0 e8 71 82 5a e1 <0f> 0b 0f 0b 66 66 66 66 2e 0f 1f 84 00 00 00 00 00 55 48 89 e5 
[    4.981691] RIP  [<ffffffffa00e6ecf>] __btrfs_map_block+0x62f/0x640 [btrfs]
[    4.982419]  RSP <ffff88001ae1d898>
[    4.982759] ---[ end trace 8dad38c6dfd75317 ]---


Version-Release number of selected component (if applicable):

kernel 3.3.2-1.fc17.x86_64.debug
btrfs-progs-0.19-19.fc18.x86_64

How reproducible:

unknown, at least twice

Steps to Reproduce:
1. mkfs.btrfs /dev/vda1 /dev/vdb1
2. mount /dev/vda1 /sysroot

Actual results:

Panic as shown above.

Expected results:

Shouldn't panic.

Additional info:

I have just compiled the btrfs-next kernel, so I will try that
in a moment.
Comment 1 Richard W.M. Jones 2012-04-25 16:25:59 EDT
DOESN'T happen with btrfs-next kernel.
Comment 2 Josef Bacik 2012-04-26 11:02:46 EDT
Created attachment 580505 [details]
possible fix

Well if you are feeling particularly squirrely you can apply this to the f17 fedora kernel and build it and see if it fixes it in fedora, but if you just want to keep using btrfs-next that works too :).
Comment 3 Richard W.M. Jones 2012-05-25 12:56:57 EDT
Bugzilla seems to have eaten that patch.  However I will
try applying 3c4bb26b213e618473e486776483a5bad15ba6da from
the upstream kernel to Fedora and see if that makes any
difference.  I can 100% reliably reproduce this bug.
Comment 4 Richard W.M. Jones 2012-05-26 05:06:48 EDT
Backporting that patch (or perhaps some other coincidental
change when I moved to 3.3.7-2.fc17.x86_64) does appear to
have fixed the problem.

Would it be possible to include a newer version of btrfs
with this fix in F17?
Comment 5 Josh Boyer 2012-05-30 08:54:45 EDT
3c4bb26b213e618473e486776483a5bad15ba6da is in the 3.4 kernel.  F17 will be rebased to 3.4 by the end of the week.
Comment 6 Josh Boyer 2012-06-26 17:03:51 EDT
What i said in comment #5
Comment 7 Richard W.M. Jones 2012-06-26 17:11:39 EDT
Thanks.

Note You need to log in before you can comment on or make changes to this bug.